#ifndef __GO_BOARD_H__
#define __GO_BOARD_H__

#ifndef __cplusplus
#include <stdbool.h>
#endif /* __cplusplus */
#include <stddef.h>
#include "cdefs.h"
#include "go_types.h"


#define MAX_BOARD_SIZE	9


BEGIN_DECLS

/**
 * This structure stands for the status of the go board.
 */
struct go_board {
    stone_t board_array[MAX_BOARD_SIZE][MAX_BOARD_SIZE];

    int board_size;

    int num_captured_white;
    int num_captured_black;

    coord_t ko_x;
    coord_t ko_y;

    struct go_string_list* string_list;
};


int go_board_initialize(struct go_board*, int);
int go_board_terminate(struct go_board*);

int go_board_copy_board(struct go_board*, struct go_board*);

stone_t go_board_get_stone(struct go_board*, coord_t, coord_t);
int go_board_set_stone(struct go_board*, stone_t, coord_t, coord_t);
int go_board_remove_stone(struct go_board*, coord_t, coord_t);

int go_board_get_board_size(struct go_board*);
int go_board_display(struct go_board*);

int go_board_increment_captured_white(struct go_board*);
int go_board_increment_captured_black(struct go_board*);
int go_board_get_captured_white(struct go_board*);
int go_board_get_captured_black(struct go_board*);

int go_board_get_black(struct go_board*);
int go_board_get_white(struct go_board*);

int go_board_set_ko_position(struct go_board*, coord_t, coord_t);
int go_board_get_ko_position(struct go_board*, coord_t*, coord_t*);

END_DECLS

#endif /* __GO_BOARD_H__ */
