#ifndef __GO_ENGINE_H__
#define __GO_ENGINE_H__

#include "cdefs.h"
#include "go_types.h"
#include "go_board.h"

#include <stddef.h>
#include <stdint.h>


BEGIN_DECLS

int go_engine_initialize(int, stone_t, float);
int go_engine_terminate(void);
int go_engine_reinitialize(void);

int go_engine_set_opponent_move(move_t, coord_t, coord_t);
int go_engine_get_next_move(move_t*, coord_t*, coord_t*);

int go_engine_get_current_score(score_t*);

int go_engine_set_boardsize(int);
int go_engine_set_komi(float);
int go_engine_set_time_settings(int, int);

int go_engine_load_sgf_file(const char*, int);

END_DECLS

#endif /* __GO_ENGINE_H__ */
