#ifndef __GO_TYPES_H__
#define __GO_TYPES_H__

#define STONE_COLOR_EMPTY       0U
#define STONE_COLOR_BLACK       1U
#define STONE_COLOR_WHITE       2U

#define MOVE_FLAGS_NORMAL       0x00000001U
#define MOVE_FLAGS_PASS         0x00000002U
#define MOVE_FLAGS_RESIGN       0x00000004U

#define STONE_COORD_INVALID     -1
#define MOVE_COUNT_INVALID      -1
#define STRING_ID_INVALID       -1


typedef unsigned int stone_t;
typedef unsigned int move_t;
typedef int coord_t;
typedef int string_id_t;
typedef int linkage_id_t;
typedef int group_id_t;

typedef struct {
    coord_t x;
    coord_t y;
} coord2d_t;

typedef struct {
    unsigned int black_score;
    unsigned int white_score;
} score_t;

#endif /* __GO_TYPES_H__ */
