#include <Windows.h>
#include <stdarg.h>
#include <stdio.h>
#include "utility.h"


/**
 * This funciton returns the current time in usec.
 *
 * \retval usec  Current time in usec
 */
int64_t current_time_get(void)
{
    LARGE_INTEGER t, freq;
    QueryPerformanceCounter(&t);
    QueryPerformanceFrequency(&freq);
    return (1000 * 1000 * t.QuadPart)/freq.QuadPart;
}


/**
 * Wrapper function for snprintf().
 */
int snprintf(char *str, size_t size, const char *format, ...)
{
    int rv;
    va_list list;

    va_start(list, format);
    rv = _vsnprintf(str, size, format, list);
    va_end(list);

    return rv;
}


/**
 * This function returns the process ID.
 */
int process_id_get(void)
{
    return GetCurrentProcessId();
}
